this.primevue = this.primevue || {};
this.primevue.autocomplete = this.primevue.autocomplete || {};
this.primevue.autocomplete.style = (function (BaseStyle, utils) {
    'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    var BaseStyle__default = /*#__PURE__*/_interopDefaultLegacy(BaseStyle);

    var css = "\n@layer primevue {\n    .p-autocomplete {\n        display: inline-flex;\n    }\n\n    .p-autocomplete-loader {\n        position: absolute;\n        top: 50%;\n        margin-top: -0.5rem;\n    }\n\n    .p-autocomplete-dd .p-autocomplete-input {\n        flex: 1 1 auto;\n        width: 1%;\n    }\n\n    .p-autocomplete-dd .p-autocomplete-input,\n    .p-autocomplete-dd .p-autocomplete-multiple-container {\n        border-top-right-radius: 0;\n        border-bottom-right-radius: 0;\n    }\n\n    .p-autocomplete-dd .p-autocomplete-dropdown {\n        border-top-left-radius: 0;\n        border-bottom-left-radius: 0px;\n    }\n\n    .p-autocomplete .p-autocomplete-panel {\n        min-width: 100%;\n    }\n\n    .p-autocomplete-panel {\n        position: absolute;\n        overflow: auto;\n        top: 0;\n        left: 0;\n    }\n\n    .p-autocomplete-items {\n        margin: 0;\n        padding: 0;\n        list-style-type: none;\n    }\n\n    .p-autocomplete-item {\n        cursor: pointer;\n        white-space: nowrap;\n        position: relative;\n        overflow: hidden;\n    }\n\n    .p-autocomplete-multiple-container {\n        margin: 0;\n        padding: 0;\n        list-style-type: none;\n        cursor: text;\n        overflow: hidden;\n        display: flex;\n        align-items: center;\n        flex-wrap: wrap;\n    }\n\n    .p-autocomplete-token {\n        cursor: default;\n        display: inline-flex;\n        align-items: center;\n        flex: 0 0 auto;\n    }\n\n    .p-autocomplete-token-icon {\n        cursor: pointer;\n    }\n\n    .p-autocomplete-input-token {\n        flex: 1 1 auto;\n        display: inline-flex;\n    }\n\n    .p-autocomplete-input-token input {\n        border: 0 none;\n        outline: 0 none;\n        background-color: transparent;\n        margin: 0;\n        padding: 0;\n        box-shadow: none;\n        border-radius: 0;\n        width: 100%;\n    }\n\n    .p-fluid .p-autocomplete {\n        display: flex;\n    }\n\n    .p-fluid .p-autocomplete-dd .p-autocomplete-input {\n        width: 1%;\n    }\n}\n";
    var inlineStyles = {
      root: {
        position: 'relative'
      }
    };
    var classes = {
      root: function root(_ref) {
        var instance = _ref.instance,
          props = _ref.props;
        return ['p-autocomplete p-component p-inputwrapper', {
          'p-disabled': props.disabled,
          'p-invalid': props.invalid,
          'p-focus': instance.focused,
          'p-autocomplete-dd': props.dropdown,
          'p-autocomplete-multiple': props.multiple,
          'p-inputwrapper-filled': props.modelValue || utils.ObjectUtils.isNotEmpty(instance.inputValue),
          'p-inputwrapper-focus': instance.focused,
          'p-overlay-open': instance.overlayVisible
        }];
      },
      input: function input(_ref2) {
        var props = _ref2.props,
          instance = _ref2.instance;
        return ['p-autocomplete-input p-inputtext p-component', {
          'p-autocomplete-dd-input': props.dropdown,
          'p-variant-filled': props.variant ? props.variant === 'filled' : instance.$primevue.config.inputStyle === 'filled'
        }];
      },
      container: function container(_ref3) {
        var props = _ref3.props,
          instance = _ref3.instance;
        return ['p-autocomplete-multiple-container p-component p-inputtext', {
          'p-variant-filled': props.variant ? props.variant === 'filled' : instance.$primevue.config.inputStyle === 'filled'
        }];
      },
      token: function token(_ref4) {
        var instance = _ref4.instance,
          i = _ref4.i;
        return ['p-autocomplete-token', {
          'p-focus': instance.focusedMultipleOptionIndex === i
        }];
      },
      tokenLabel: 'p-autocomplete-token-label',
      removeTokenIcon: 'p-autocomplete-token-icon',
      inputToken: 'p-autocomplete-input-token',
      loadingIcon: 'p-autocomplete-loader',
      dropdownButton: 'p-autocomplete-dropdown',
      panel: function panel(_ref5) {
        _ref5.props;
          var instance = _ref5.instance;
        return ['p-autocomplete-panel p-component', {
          'p-ripple-disabled': instance.$primevue.config.ripple === false
        }];
      },
      list: 'p-autocomplete-items',
      itemGroup: 'p-autocomplete-item-group',
      item: function item(_ref6) {
        var instance = _ref6.instance,
          option = _ref6.option,
          i = _ref6.i,
          getItemOptions = _ref6.getItemOptions;
        return ['p-autocomplete-item', {
          'p-highlight': instance.isSelected(option),
          'p-focus': instance.focusedOptionIndex === instance.getOptionIndex(i, getItemOptions),
          'p-disabled': instance.isOptionDisabled(option)
        }];
      },
      emptyMessage: 'p-autocomplete-empty-message'
    };
    var AutoCompleteStyle = BaseStyle__default["default"].extend({
      name: 'autocomplete',
      css: css,
      classes: classes,
      inlineStyles: inlineStyles
    });

    return AutoCompleteStyle;

})(primevue.base.style, primevue.utils);
