import BaseStyle from 'primevue/base/style';

var css = "\n@layer primevue {\n    .p-confirm-popup {\n        position: absolute;\n        margin-top: 10px;\n        top: 0;\n        left: 0;\n    }\n\n    .p-confirm-popup-flipped {\n        margin-top: 0;\n        margin-bottom: 10px;\n    }\n\n    /* Animation */\n    .p-confirm-popup-enter-from {\n        opacity: 0;\n        transform: scaleY(0.8);\n    }\n\n    .p-confirm-popup-leave-to {\n        opacity: 0;\n    }\n\n    .p-confirm-popup-enter-active {\n        transition: transform 0.12s cubic-bezier(0, 0, 0.2, 1), opacity 0.12s cubic-bezier(0, 0, 0.2, 1);\n    }\n\n    .p-confirm-popup-leave-active {\n        transition: opacity 0.1s linear;\n    }\n\n    .p-confirm-popup:after,\n    .p-confirm-popup:before {\n        bottom: 100%;\n        left: calc(var(--overlayArrowLeft, 0) + 1.25rem);\n        content: ' ';\n        height: 0;\n        width: 0;\n        position: absolute;\n        pointer-events: none;\n    }\n\n    .p-confirm-popup:after {\n        border-width: 8px;\n        margin-left: -8px;\n    }\n\n    .p-confirm-popup:before {\n        border-width: 10px;\n        margin-left: -10px;\n    }\n\n    .p-confirm-popup-flipped:after,\n    .p-confirm-popup-flipped:before {\n        bottom: auto;\n        top: 100%;\n    }\n\n    .p-confirm-popup.p-confirm-popup-flipped:after {\n        border-bottom-color: transparent;\n    }\n\n    .p-confirm-popup.p-confirm-popup-flipped:before {\n        border-bottom-color: transparent;\n    }\n\n    .p-confirm-popup .p-confirm-popup-content {\n        display: flex;\n        align-items: center;\n    }\n}\n";
var classes = {
  root: function root(_ref) {
    var instance = _ref.instance;
    return ['p-confirm-popup p-component', {
      'p-ripple-disabled': instance.$primevue.config.ripple === false
    }];
  },
  content: 'p-confirm-popup-content',
  icon: 'p-confirm-popup-icon',
  message: 'p-confirm-popup-message',
  footer: 'p-confirm-popup-footer',
  rejectButton: function rejectButton(_ref2) {
    var instance = _ref2.instance;
    return ['p-confirm-popup-reject', instance.confirmation && !instance.confirmation.rejectClass ? 'p-button-sm p-button-text' : null];
  },
  acceptButton: function acceptButton(_ref3) {
    var instance = _ref3.instance;
    return ['p-confirm-popup-accept', instance.confirmation && !instance.confirmation.acceptClass ? 'p-button-sm' : null];
  }
};
var ConfirmPopupStyle = BaseStyle.extend({
  name: 'confirmpopup',
  css: css,
  classes: classes
});

export { ConfirmPopupStyle as default };
